﻿using msoui.Models;

namespace msoui.Forms;

internal sealed partial class ScanDirForm : Form
{
    private const string SearchFile = "&Пожалуйста, подождите. Идёт поиск файлов. Найдено: {0} файлов...";

    public ScanDirForm(ScanDirModel model)
    {
        Model = model;
        InitializeComponent();
    }

    public ScanDirModel Model { get; set; }

    private void AddStatus(string message, params object[] args)
    {
        statusLabel.Text = string.Format(message, args);
        Application.DoEvents();
    }

    public void ScanForFiles()
    {
        //Счётчик найденных
        int foundsCount = 0;

        //Добавляю статусное сообщение
        AddStatus(SearchFile, foundsCount);

        //Осуществляю подсчёт файлов
        foreach (string file in Directory.EnumerateFiles(Model.SearchDir, Model.Mask,
                     Model.ScanSubDirs ? SearchOption.AllDirectories : SearchOption.TopDirectoryOnly))
        {
            try
            {
                //Получаю информацию о файле
                FileInfo info = new(file);

                //Добавляю имя файла в список
                Model.FoundList.Add(info.Name);

                //Увеличиваю число найденных
                foundsCount++;

                //Добавляю статус
                AddStatus(SearchFile, foundsCount);
            }
            catch
            {
                // ignored
            }
        }

        //Выхожу из формы
        DialogResult = DialogResult.OK;
    }

    private void startTimer_Tick(object sender, EventArgs e)
    {
        startTimer.Enabled = false;
        ScanForFiles();
    }

    private void UnPackForm_Load(object sender, EventArgs e)
    {
        startTimer.Enabled = true;
    }
}