﻿using msoui.Models;

namespace msoui.Forms;

internal sealed partial class UpdatesListForm : Form
{
    private const string SelectionStatusLabel = "{0} выбрано из {1}";

    public UpdatesListForm(ListModel model)
    {
        Model = model;
        InitializeComponent();
    }

    public ListModel Model { get; set; }

    private void selectAllButton_Click(object sender, EventArgs e)
    {
        for (int index = 0; index < updatesListBox.Items.Count; index++)
            updatesListBox.SetItemCheckState(index, CheckState.Checked);
    }

    private void UpdatesListForm_Load(object sender, EventArgs e)
    {
        updatesListBox.Items.Clear();

        foreach (string item in Model.InList)
            updatesListBox.Items.Add(item, CheckState.Checked);
    }

    private void checkedUpdateTimer_Tick(object sender, EventArgs e)
    {
        selectionStatus.Text = string.Format(SelectionStatusLabel, updatesListBox.CheckedItems.Count,
            updatesListBox.Items.Count);
    }

    private void installButton_Click(object sender, EventArgs e)
    {
        Model.OutList.Clear();

        foreach (object checkedItem in updatesListBox.CheckedItems.Cast<object>()
                     .Where(static checkedItem => checkedItem.ToString() != null))
            // ReSharper disable once NullableWarningSuppressionIsUsed
            Model.OutList.Add(checkedItem.ToString()!);

        DialogResult = DialogResult.OK;
    }

    private void cancelButton_Click(object sender, EventArgs e)
    {
        DialogResult = DialogResult.Cancel;
    }
}